#pragma once
#include "AutoLock.h"

template<class T>
class CSingletonT
{
protected:
	CSingletonT(void){}
	virtual ~CSingletonT(void){}

public:
	static T* Instance()
	{
		CAutoLock autoLock(&s_CS);
		static T Instace;
		return &Instace;
	}

private:
	static CrSectionEx s_CS;
};

template<class T> CrSectionEx CSingletonT<T>::s_CS;
